#pragma once
#include <vector>
#include "LSMacros.h"

template <class T>

class LSVector
{
public:
  LSVector(size_t zSize = 0)
  {
    m_pData = new T[zSize];
    m_zSize = zSize;
    m_zCapacity = zSize;
  }

  ~LSVector()
  {
    Clear();
  }

  T& PushBack(T oObj)
  {
    return Insert(oObj, m_zSize);
  }

  void PopBack()
  {
    --m_zSize;
  }

  T& Insert(T oObj, const size_t zPos)
  {
    m_pData[zPos] = oObj;
    m_zSize++;
    return m_pData[zPos];
  }

  T& At(const size_t zPos)
  {
    return m_pData[zPos];
  }

  void Resize(const size_t zNewSize)
  {
    T* pOld = m_pData;
    m_pData = new T[zNewSize];

    memmove_s(m_pData, zNewSize, pOld, m_zSize);
    m_zSize = zNewSize;
    m_zCapacity = zNewSize;

    DELETE_ARRAY(pOld)
  }

  void Reserve(const size_t zSize)
  {
    T* pOld = m_pData;
    m_pData = (T*)malloc(zSize * sizeof(T));

    memmove_s(m_pData, zSize, pOld, m_zSize);
    m_zSize = zSize;
    m_zCapacity = zSize;

    DELETE_ARRAY(pOld)
  }

  void Clear() 
  {
    DELETE_ARRAY(m_pData)
    m_zSize = 0;
    m_zCapacity = 0;
  }

  size_t Size() const
  {
    return m_zSize;
  }

  size_t Capacity() const
  {
    return m_zCapacity;
  }

  T* Data() const
  {
    return m_pData;
  }

  LSVector& operator=(const LSVector oRhs)
  {

  }

  LSVector& operator[](const size_t _Pos)
  {
    test.reserve(5);
    test.resize(5);
  }

private:
  std::vector<int> test;
  T* m_pData = nullptr;
  size_t m_zSize = 0;
  size_t m_zCapacity = 0;
};